--
-- Remote Codec for Softube's Console 1 controller
--    (c) Birgit Jauernig
--        2016-02-19
--
-- Version 0.0.1

function remote_init(manufacturer, model)

	local items=
	{
		{name="CC 07",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 10",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 12",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 13",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 14",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 15",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 17",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 18",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 21",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 22",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 23",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 24",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 25",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 26",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 27",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 28",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 29",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 30",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 31",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 32",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 33",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 34",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 35",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 36",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 37",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 38",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 39",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 40",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 46",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 47",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 48",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 49",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 50",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 51",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 53",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 54",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 55",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 56",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 57",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 58",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 59",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 61",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 65",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 80",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 82",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 83",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 85",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 86",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 87",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 88",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 89",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 90",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 91",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 92",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 93",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 96",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 97",             	input="value",	output="value",	min=0,	max=127},
		{name="CC 102",            	input="value",	output="value",	min=0,	max=127},
		{name="CC 103",            	input="value",	output="value",	min=0,	max=127},
		{name="CC 104",            	input="value",	output="value",	min=0,	max=127},
		{name="CC 105",            	input="value",	output="value",	min=0,	max=127},
		{name="CC 107",            	input="value",	output="value",	min=0,	max=127},
		{name="CC 108",            	input="value",	output="value",	min=0,	max=127},
		{name="CC 110",            					output="value",	min=0,	max=127},
		{name="CC 111",            					output="value",	min=0,	max=127},
		{name="CC 112",            					output="value",	min=0,	max=127},
		{name="CC 113",            					output="value",	min=0,	max=127},
		{name="CC 114",            					output="value",	min=0,	max=127},
		{name="CC 115",            					output="value",	min=0,	max=127},
		{name="CC 120",            	input="value",	output="value",	min=0,	max=127},
		{name="CC 123",            	input="value",	output="value",	min=0,	max=127},
	}
	remote.define_items(items)

	local inputs=
	{
		{pattern="b0 07 xx",     	name="CC 07"},
		{pattern="b0 0A xx",     	name="CC 10"},
		{pattern="b0 0C xx",     	name="CC 12"},
		{pattern="b0 0D xx",     	name="CC 13"},
		{pattern="b0 0E xx",     	name="CC 14", value="x+63"},
		{pattern="b0 0F xx",     	name="CC 15"},
		{pattern="b0 11 xx",     	name="CC 17", value="x*2"},
		{pattern="b0 12 xx",     	name="CC 18"},
		{pattern="b0 15 xx",     	name="CC 21"},
		{pattern="b0 16 xx",     	name="CC 22"},
		{pattern="b0 17 xx",     	name="CC 23"},
		{pattern="b0 18 xx",     	name="CC 24"},
		{pattern="b0 19 xx",     	name="CC 25"},
		{pattern="b0 1A xx",     	name="CC 26"},
		{pattern="b0 1B xx",     	name="CC 27"},
		{pattern="b0 1C xx",     	name="CC 28"},
		{pattern="b0 1D xx",     	name="CC 29"},
		{pattern="b0 1E xx",     	name="CC 30"},
		{pattern="b0 1F xx",     	name="CC 31"},
		{pattern="b0 20 xx",     	name="CC 32"},
		{pattern="b0 21 xx",     	name="CC 33"},
		{pattern="b0 22 xx",     	name="CC 34"},
		{pattern="b0 23 xx",     	name="CC 35"},
		{pattern="b0 24 xx",     	name="CC 36"},
		{pattern="b0 25 xx",     	name="CC 37"},
		{pattern="b0 26 xx",     	name="CC 38"},
		{pattern="b0 27 xx",     	name="CC 39"},
		{pattern="b0 28 xx",     	name="CC 40"},
		{pattern="b0 2E xx",     	name="CC 46"},
		{pattern="b0 2F xx",     	name="CC 47"},
		{pattern="b0 30 xx",     	name="CC 48"},
		{pattern="b0 31 xx",     	name="CC 49"},
	--	{pattern="b0 32 xx",     	name="CC 50"},
	--	{pattern="b0 33 <??x?>?",   name="CC 51", value="127-x*127"},
		{pattern="b0 35 xx",     	name="CC 53"},
		{pattern="b0 36 xx",     	name="CC 54"},
		{pattern="b0 37 xx",     	name="CC 55"},
		{pattern="b0 38 xx",     	name="CC 56"},
		{pattern="b0 39 xx",     	name="CC 57"},
		{pattern="b0 3A xx",     	name="CC 58"},
		{pattern="b0 3B xx",     	name="CC 59"},
		{pattern="b0 3D xx",     	name="CC 61"},
		{pattern="b0 41 xx",     	name="CC 65", value="x*2"},
		{pattern="b0 50 xx",     	name="CC 80"},
		{pattern="b0 52 xx",     	name="CC 82"},
		{pattern="b0 53 xx",     	name="CC 83"},
		{pattern="b0 55 xx",     	name="CC 85"},
		{pattern="b0 56 xx",     	name="CC 86"},
		{pattern="b0 57 xx",     	name="CC 87"},
		{pattern="b0 58 xx",     	name="CC 88"},
		{pattern="b0 59 xx",     	name="CC 89"},
		{pattern="b0 5A xx",     	name="CC 90"},
		{pattern="b0 5B xx",     	name="CC 91"},
		{pattern="b0 5C xx",     	name="CC 92"},
		{pattern="b0 5D xx",     	name="CC 93", value="x*2"},
		{pattern="b0 60 xx",     	name="CC 96"},
		{pattern="b0 61 xx",     	name="CC 97"},
		{pattern="b0 66 xx",     	name="CC 102"},
		{pattern="b0 67 xx",     	name="CC 103"},
		{pattern="b0 68 xx",     	name="CC 104"},
		{pattern="b0 69 xx",     	name="CC 105"},
		{pattern="b0 6B xx",     	name="CC 107"},
		{pattern="b0 6C xx",     	name="CC 108"},
		{pattern="b0 78 xx",     	name="CC 120"},
		{pattern="b0 7B xx",     	name="CC 123"},
	}
	remote.define_auto_inputs(inputs)

	local outputs={
		{name="CC 07"           ,	pattern="b0 07 xx"},
		{name="CC 10"           ,	pattern="b0 0A xx"},
		{name="CC 12"           ,	pattern="b0 0C xx"},
		{name="CC 13"           ,	pattern="b0 0D xx"},
		{name="CC 14"           ,	pattern="b0 0E xx", x="(value+1)/2+63"},
		{name="CC 15"           ,	pattern="b0 0F xx"},
		{name="CC 17"           ,	pattern="b0 11 xx", x="value/1.5"},
		{name="CC 18"           ,	pattern="b0 12 xx"},
		{name="CC 21"           ,	pattern="b0 15 xx"},
		{name="CC 22"           ,	pattern="b0 16 xx"},
		{name="CC 23"           ,	pattern="b0 17 xx"},
		{name="CC 24"           ,	pattern="b0 18 xx"},
		{name="CC 25"           ,	pattern="b0 19 xx"},
		{name="CC 26"           ,	pattern="b0 1A xx"},
		{name="CC 27"           ,	pattern="b0 1B xx"},
		{name="CC 28"           ,	pattern="b0 1C xx"},
		{name="CC 29"           ,	pattern="b0 1D xx"},
		{name="CC 30"           ,	pattern="b0 1E xx"},
		{name="CC 31"           ,	pattern="b0 1F xx"},
		{name="CC 32"           ,	pattern="b0 20 xx"},
		{name="CC 33"           ,	pattern="b0 21 xx"},
		{name="CC 34"           ,	pattern="b0 22 xx"},
		{name="CC 35"           ,	pattern="b0 23 xx"},
		{name="CC 36"           ,	pattern="b0 24 xx"},
		{name="CC 37"           ,	pattern="b0 25 xx"},
		{name="CC 38"           ,	pattern="b0 26 xx"},
		{name="CC 39"           ,	pattern="b0 27 xx"},
		{name="CC 40"           ,	pattern="b0 28 xx"},
		{name="CC 46"           ,	pattern="b0 2E xx"},
		{name="CC 47"           ,	pattern="b0 2F xx"},
		{name="CC 48"           ,	pattern="b0 30 xx"},
		{name="CC 49"           ,	pattern="b0 31 xx"},
	--	{name="CC 50"           ,	pattern="b0 32 xx"},
		{name="CC 51"           ,	pattern="b0 33 xx", x="(1-remote.get_item_value(33)/127)*85+(1-remote.get_item_value(34)/127)*42"},
		{name="CC 53"           ,	pattern="b0 35 xx"},
		{name="CC 54"           ,	pattern="b0 36 xx"},
		{name="CC 55"           ,	pattern="b0 37 xx"},
		{name="CC 56"           ,	pattern="b0 38 xx"},
		{name="CC 57"           ,	pattern="b0 39 xx"},
		{name="CC 58"           ,	pattern="b0 3A xx"},
		{name="CC 59"           ,	pattern="b0 3B xx"},
		{name="CC 61"           ,	pattern="b0 3D xx"},
		{name="CC 65"           ,	pattern="b0 41 xx", x="value/1.5"},
		{name="CC 80"           ,	pattern="b0 50 xx"},
		{name="CC 82"           ,	pattern="b0 52 xx"},
		{name="CC 83"           ,	pattern="b0 53 xx"},
		{name="CC 85"           ,	pattern="b0 55 xx"},
		{name="CC 86"           ,	pattern="b0 56 xx"},
		{name="CC 87"           ,	pattern="b0 57 xx"},
		{name="CC 88"           ,	pattern="b0 58 xx"},
		{name="CC 89"           ,	pattern="b0 59 xx"},
		{name="CC 90"           ,	pattern="b0 5A xx"},
		{name="CC 91"           ,	pattern="b0 5B xx"},
		{name="CC 92"           ,	pattern="b0 5C xx"},
		{name="CC 93"           ,	pattern="b0 5D xx", x="value/1.5"},
		{name="CC 96"           ,	pattern="b0 60 xx"},
		{name="CC 97"           ,	pattern="b0 61 xx"},
		{name="CC 102"          ,	pattern="b0 66 xx"},
		{name="CC 103"          ,	pattern="b0 67 xx"},
		{name="CC 104"          ,	pattern="b0 68 xx"},
		{name="CC 105"          ,	pattern="b0 69 xx"},
		{name="CC 107"          ,	pattern="b0 6B xx"},
		{name="CC 108"          ,	pattern="b0 6C xx"},
		{name="CC 110"          ,	pattern="b0 6E xx"},
		{name="CC 111"          ,	pattern="b0 6F xx"},
		{name="CC 112"          ,	pattern="b0 70 xx"},
		{name="CC 113"          ,	pattern="b0 71 xx"},
		{name="CC 114"          ,	pattern="b0 72 xx", x="(value*(-1))+127"},
		{name="CC 115"          ,	pattern="b0 73 xx", x="(value*(-1))+127"},
		{name="CC 120"          ,	pattern="b0 78 xx"},
		{name="CC 123"          ,	pattern="b0 7B xx"},
	}
	remote.define_auto_outputs(outputs)
end

function remote_process_midi(event)
	ret=remote.match_midi("b0 33 <?xy?>?", event)
	if ret~=nil then
		remote.handle_input({item=33, value=127-ret.x*127})
		remote.handle_input({item=34, value=127-ret.y*127})
		return true
	end
	return false
end

function remote_probe()
	return {
		-- does not respond
	}
end

function remote_prepare_for_use()
	local retEvents={
	}
	return retEvents
end

function remote_release_from_use()
	local retEvents={
	}
	return retEvents
end

